/*
 Processo USBD
 Questo  un processo sistema che si occupa dell'hotplug delle periferiche usb.
 Ogni WAIT_FOR_HOTPLUG secondi controlla le porte 1 e 2 dell'root hub e se ad 
 una delle due  stato attaccata una periferica lancia le primitive di I/O 
 atte alla configurazione.
 */

#define	WAIT_FOR_HOTPLUG	100 //circa 10 secondi!

 
#include <sys.h>
#include <lib.h>
#include <dma.h>

//semaforo di sincronizzazione per i dati contenuti in usb_buffer

extern int semaforo_USB_PRINT;
//semaforo di sincronizzazione per le periferiche connesse

extern int semaforo_USB_PRESENT;

//buffer per i dati da inviare alla stampante

extern char usb_buffer[200]; 
extern int lun;

/*
 * Processo USBD
 */

#include <string.h>

void pm(int a)
{
	bool configured=false;
	bool printed=false/*true*/;//true solo per il debug!

	int port=0;
	int type=0;
	bool stato=true;
	printf(a,"Terminale di LOG del processo USBD.\n");
	while(stato)
	{
		waitforconnectusb(port,type);
		if(port==0)
			printf(a,"Nessuna periferica USB presente!\n");
		if(port==1)
		{
			if(configured==false)
			{
				//segnalo la presenza di un nuovo device

				if(type==7)// connessa una stampante?

					{//libero il processo di prova per la stampa

						sem_signal(semaforo_USB_PRESENT);
					}
				configured=true;
			}
			printf(a,"Periferica connessa!\n");
			if(printed==false)
			{
				sem_wait(semaforo_USB_PRINT);//attendo la stringa da stampare (bloccante)

				printf(a,"Stampo la stringa seguente:\n");
				printf(a,usb_buffer);
				print_text(usb_buffer,lun);//invio la stringa al device

				printed=true;
				
			}
		}
		//non  presente sul bus PCI un controllore USB il demone USBD va terminato

		if(port==-1)
			stato=false;
		delay(WAIT_FOR_HOTPLUG);
	} 
	terminate_p();
	
end:	;

	terminate_p();
}
