/*
 * Programma Stampa
 * Questo programma testa il driver del controllore UHCI invocando una primitiva di ststema
 * per la stampa
 */

#include <sys.h>
#include <lib.h>

//semaforo condiviso con USBD di sincronizzazione dei dati contenuti nel usb_buffer

extern int semaforo_USB_PRINT;
//semaforo di sincronizzazione (sblocca il processo solo al termine della configurazione 

//della stampante!

extern int semaforo_USB_PRESENT;
/*
 * Processo S
 */
extern char usb_buffer[2000]; 
extern int lun;

void ps(int a)
{
	usb_buffer[0]=0;
	char buf[2000];
	bool stato=true;
	char* punt;
	buf[0]=0;
	int rim=2000;
	int pos=1;
	printf(a, "Processo di prova per la stampa su una stampante USB\n");
	printf(a, "Attendo la connessione di una stampante al bus!\n");
	sem_wait(semaforo_USB_PRESENT);
	printf(a, "Stampante connessa e configurata!\n");
	printf(a,"Digitare il testo da stampare concluso da un punto su una sola linea:\n");
	usb_buffer[0]='\r';
	punt=&usb_buffer[1];
	while(rim!=0 && stato)
	{
		term_read_n(a,buf,lun);	
		if(buf[0]=='.')
			stato=false;
		else
		{
			buf[lun-1]='\r';
			rim=rim-lun;
			strncpy(punt,buf,lun);
			pos+=lun;
			punt=&usb_buffer[pos];
			lun=rim;
			buf[0]=0;
		}
	}
	lun=pos;
	printf(a, "Invio stringa da stampare alla stampante!\n");
	sem_signal(semaforo_USB_PRINT);
	printf(a, "Testo da stampare inviato al demone!\n");

	terminate_p();
}
